'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getLocale = exports.getP = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _redux = require('redux');

var _reselect = require('reselect');

var _nodePolyglot = require('node-polyglot');

var _nodePolyglot2 = _interopRequireDefault(_nodePolyglot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var path = function path(arrPath) {
    return function (obj) {
        return arrPath.reduce(function (cursor, key) {
            return cursor && cursor[key];
        }, obj);
    };
};
var toUpper = function toUpper(str) {
    return str.toUpperCase();
};
var adjustString = function adjustString(f, index) {
    return function (str) {
        return str.substr(0, index) + f(str[index]) + str.substr(index + 1);
    };
};
var capitalize = adjustString(toUpper, 0);

var getLocale = path(['polyglot', 'locale']);
var getPhrases = path(['polyglot', 'phrases']);

var getPolyglot = (0, _reselect.createSelector)(getLocale, getPhrases, function (locale, phrases) {
    var p = new _nodePolyglot2.default({
        locale: locale,
        phrases: phrases
    });
    return p;
});

var getTranslation = (0, _reselect.createSelector)(getPolyglot, function (p) {
    return p.t.bind(p);
});

var getTranslationMorphed = function getTranslationMorphed(state) {
    return function (f) {
        return (0, _redux.compose)(f, getTranslation(state));
    };
};
var getTranslationUpperCased = function getTranslationUpperCased(state) {
    return getTranslationMorphed(state)(toUpper);
};
var getTranslationCapitalized = function getTranslationCapitalized(state) {
    return getTranslationMorphed(state)(capitalize);
};

var getP = function getP(state) {
    if (!getLocale(state) || !getPhrases(state)) return undefined;
    return _extends({}, getPolyglot(state), {
        t: getTranslation(state),
        tc: getTranslationCapitalized(state),
        tu: getTranslationUpperCased(state),
        tm: getTranslationMorphed(state)
    });
};

exports.getP = getP;
exports.getLocale = getLocale;